#ifndef M98_M_H 
#define M98_M_H

/** \file Definitions for math stuff.
*/
/*
   $Log: m.h,v $
   Revision 1.1.1.1  2009/05/07 12:58:12  kraemer


   Revision 1.8.2.5  2009/05/07 12:27:12  kraemer
   64bit-clean

   Revision 1.8.2.4  2008/06/20 17:02:05  kraemer
   platform stuff

   Revision 1.8.2.3  2006/01/07 12:35:52  kraemer
   OSX sync

   Revision 1.8.2.2  2005/03/16 00:55:00  kraemer
   *** empty log message ***

   Revision 1.8.2.1  2005/03/15 14:25:58  kraemer
   *** empty log message ***

   Revision 1.8  2004/07/27 16:51:51  kraemer
   vintpolmt1() added

   Revision 1.7  2000/04/03 12:31:38  kraemer
   c2* and other prototypes

   Revision 1.6  1999/12/16 12:42:55  kraemer
   prototypes added

   Revision 1.5  1999/02/02 19:56:24  kraemer
   function prototypes added (random generators)

   Revision 1.4  1997/12/15 17:28:41  kraemer
   branches for native gammafunction, nan declarations

   Revision 1.3  1997/07/10 17:26:10  kraemer
   *** empty log message ***

   Revision 1.2  1997/06/16 18:15:51  kraemer
   more prototypes

*/

#include <float.h>
#include <math.h>

#include "mtypes.h"
#include "c2num.h"
#include "mmathfct.h"
#include "vmathfct.h"
#include "vrandom.h"
#include "vintpol.h"
#include "msplines.h"



int fndpeak(double *, double *, double *, double *, size_t, double [6],
            double *, int );
ssize_t Pathfinder ( size_t, double *, double *, double, double, double, double, ssize_t ** );

double vtrapz ( double *, ssize_t, double *, ssize_t, double *, ssize_t, size_t );
double vtrapz1( double *, ssize_t, double *, ssize_t, double *, ssize_t, size_t );
double romint( 
               double (*)( double, double [], int ),
	              double [],        /* [nPar] */
	              int,
	              double [2],
	              int,
	              double,
	              double [],       /* [nHalf+1] */
	              int
             );


ssize_t Diag5 ( double *, double *, double *, double *, double *, double *, size_t );
ssize_t Diag5c( double *, double *, double *, double *, double *, double *, size_t );
ssize_t Diag3c( double *, double *, double *, double *, size_t );
/*
int matinv( double *, int *, int *, int, double * );
*/
ssize_t InvMat( double *, size_t, ssize_t *, ssize_t *, double * );

#endif
