#ifndef UTYPES_H
#define UTYPES_H
/** \file Data type and related definitions.
   
   Copyright  2003-2015 M.Kraemer, D-64291 Darmstadt, Seegartenstr. 32,
                         all rights reserved
   $Log: utypes.h,v $
   Revision 1.5  2015/01/05 18:45:30  kraemer
   64bit stuff/macros

   Revision 1.4  2014/02/19 18:02:20  kraemer
   *** empty log message ***

   Revision 1.3  2012/02/23 19:22:46  kraemer
   str?wld? new version

   Revision 1.2  2011/09/15 16:54:22  kraemer
   table increment macro

   Revision 1.1.1.1  2009/05/06 16:21:42  kraemer


   Revision 1.1.2.2  2009/05/06 14:14:26  kraemer
   64bit-clean

   Revision 1.1.2.1  2008/06/20 16:28:04  kraemer
   *** empty log message ***


*/

/*
#if defined (__digital__) && defined (__unix__) && defined(__arch64__)
typedef  int INT32;
typedef long INT64;
typedef unsigned  int UINT32;
#else
typedef  int INT32;
typedef long long INT64;
typedef unsigned  int UINT32;
#endif
*/

#if defined(AMIGA)
#include "exec/types.h"
#else

#if defined(__EMX__)
#include <sys/types.h>
#include <sys/stat.h>
#define INCL_BASE
#define INCL_WINPROGRAMLIST
#include <os2emx.h>
#include <limits.h>
typedef   signed char       int8_t;
typedef unsigned char      uint8_t;
typedef   signed short      int16_t;
typedef unsigned short     uint16_t;
typedef   signed int        int32_t;
typedef unsigned int       uint32_t;
typedef unsigned long long uint64_t;
typedef          long long  int64_t;

#define   INT8_MAX SCHAR_MAX
#define   INT8_MIN SCHAR_MIN
#define  INT16_MAX SHRT_MAX
#define  INT16_MIN SHRT_MIN
#define  INT32_MAX  INT_MAX
#define  INT32_MIN  INT_MIN
#define UINT32_MAX UINT_MAX
#endif

#if 0 \
    || defined(__APPLE_CC__) \
    || defined(__linux__) \
    || ( defined(sun) || defined(__sun) )
#include <stdint.h>
#endif

#include "osversion.h"

#if 0 \
    || defined(__hpux) \
    || defined(__osf__) 
#include <inttypes.h>
#endif

typedef unsigned char   UBYTE;      /* unsigned 8-bit quantity */
#ifndef __EMX__
typedef char            BYTE;       /* signed 8-bit quantity */
typedef unsigned short  USHORT;     /* unsigned 16-bit quantity (UWORD) */
#endif

#if defined(AMIGA) || defined(__EMX__)
#else
typedef int BOOL;
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

                                      /* inttypes.h  */
#if defined(__osf__)
#define INT8_MIN        (-127)
#define INT8_MAX        (127)
#define UINT8_MAX       (255U)
#define INT16_MIN        (-32767-1)
#define INT16_MAX        (32767)
#define UINT16_MAX       (65535U)
#define INT32_MIN       (-2147483647-1)
#define INT32_MAX       (2147483647)
#define UINT32_MAX      (4294967295U)
#endif
                                      /*  */
/*
   === 64bit integers ... 
*/   
#if ( defined(AMIGA) && defined(__SASC) ) || ( defined(__hpux) && (OSVERSION <= 900) ) 

/*
   --- ... w/o native support 
*/   
typedef struct { unsigned long ulv[2]; } ULONGLONG;
typedef struct { long lv[2]; } LONGLONG;

/*
ULONGLONG __asm muluq( register __d0 unsigned long, register __d1 unsigned long );
ULONGLONG __asm addqq( register __d0,__d1 ULONGLONG, register __d2 ULONGLONG );
*/

ULONGLONG muluq( unsigned long, unsigned long );
ULONGLONG addqq( ULONGLONG, ULONGLONG );
unsigned long divuq( ULONGLONG, unsigned long );
unsigned long moduq( ULONGLONG, unsigned long );

#define UL2ULL(ull,ul) { (ull).ulv[0] = 0; (ull).ulv[1] = (ul); }
#define ULL2UL(ul,ull) (ul) = (ull).ulv[1] 
#define ULMUL2ULL(ull,ul1,ul2) ull=muluq( (ul1), (ul2) )
#define ULLARG(ull) (ull).ulv[0],(ull).ulv[1]
                                      /* check 32bitness */
#define ULLISUL(ull) ( (ull).ulv[0] == 0 ) 
#define ULLADD2ULL(ull,ull1,ull2) ull=addqq( (ull1), (ull2) )
#define ULDIV2UL(ulRes,ull,ul)  ulRes = divuq( ull, ul)
#define ULMOD2UL(ulRem,ull,ul)  ulRem = moduq( ull, ul)
#define ULLASSIGN(ull,hi,lo) { (ull).ulv[0]=hi; (ull).ulv[1]=lo; }
#define ULLINIT(hi,lo) { hi,lo }

 LONGLONG mulsq(     long, long );
 long     divsq( LONGLONG, long );
 long     modsq( LONGLONG, long );

#define  L2LL(ll,l) { (ll).lv[0] = 0; (ll).lv[1] = (l); }
#define  LL2L(l,ll) (l) = (ll).lv[1] 
#define  LMUL2LL(ll,l1,l2) ll=mulsq( (l1), (l2) )
#define  LLARG(ll) (ll).lv[0],(ll).lv[1]
#define  LLISL(ll) ( ( (ll).lv[0] == 0 ) || ( (ll).lv[0] == ~0 ) )
/* #define  LLADD2LL(ll,ll1,ll2) ll=addqq( (ll1), (ll2) ) */
#define  LDIV2L(lDiv,ll,l)  lDiv = divsq( ll, l)
#define  LMOD2L(lRem,ll,l)  lRem = modsq( ll, l)
#define  LLASSIGN(ll,hi,lo) { (ll).lv[0]=hi; (ll).lv[1]=lo; }
#define  LLINIT(lo,hi) { hi,lo }
#define  LLNEGATE(ll) negq(ll)    

#else
/*
   --- ... w/ native support 
*/   

typedef uint64_t ULONGLONG;

#define UL2ULL(ull,ul) (ull) = (ul)
#define ULL2UL(ul,ull) (ul) = (ull)
#define ULMUL2ULL(ull,ul1,ul2) (ull) = (ULONGLONG) (ul1) * (ul2)
#define ULLARG(ull) (ull) 
                                      /* check 32bitness */
#define ULLISUL(ull) ( (ull) <= (ULONGLONG) UINT32_MAX ) 
#define ULLADD2ULL(ull,ull1,ull2) (ull) = (ull1) + (ull2)
#define ULDIV2UL(ulDiv,ull,ul)  ulDiv = (ull) / (ul)
#define ULMOD2UL(ulRem,ull,ul)  ulRem = (ull) % (ul)
#define ULLASSIGN(ull,hi,lo) ull = ULLINIT(hi,lo)
#define ULLINIT(hi,lo) ( ( (ULONGLONG) (hi)<<32 ) | (ULONGLONG) (lo) )

typedef int64_t LONGLONG;

#define  L2LL(ll,l) (ll) = (l)
#define  LL2L(l,ll) (l) = (ll) 
#define  LMUL2LL(ll,l1,l2) (ll) = (LONGLONG) (l1) * (l2)
#define  LLARG(ll) (ll) 
#define  LLISL(ll) ( ( (ll) <= (LONGLONG) INT32_MAX ) && ( (ll) >= (LONGLONG) INT32_MIN ) )
/*#define  LLADD2ULL(ull,ull1,ull2) (ull) = (ull1) + (ull2)*/
#define  LDIV2L(lDiv,ll,l)  lDiv = (ll) / (l)
#define  LMOD2L(lRem,ll,l)  lRem = (ll) % (l)
#define  LLASSIGN(ll,hi,lo) ll = LLINIT(hi,lo)
#define  LLINIT(hi,lo) ( ( (LONGLONG) (hi)<<32 ) | (LONGLONG) (lo) )
#define  LLNEGATE(ll) ll = -ll

#endif

/*
#define PRIu8           "hhu"
#define PRIu16          "hu"
#define PRIu32          "u"
#if defined(__64BIT__)
#define PRIu64          "lu"
#else
#if defined(_LONG_LONG)
#define PRIu64          "llu"
#endif
#endif
*/
#if defined(_LARGE_FILES) || (_FILE_OFFSET_BITS==64) 
#define PRIoff          "llu"
#else
#define PRIoff          "lu"  
#endif

/*
   === endianness @ compile time ... 
*/   
                                         /* defined(Lynx) */

                                         /* defined(__alpha) too ?? */
#if defined(__osf__) || defined(ultrix) || defined(__EMX__)

#undef  U_BIG_ENDIAN
#define U_LITTLE_ENDIAN

#elif defined(__hpux) || defined(sun) || defined(__mips) || defined(__APPLE_CC__) ||\
      defined(AMIGA) || defined(_AIX) || defined(MVS) || defined(mvs)

#define U_BIG_ENDIAN
#undef  U_LITTLE_ENDIAN

#elif defined(__linux__)
                                         /* linux does it itself */ 
#include <endian.h>
#if __BYTE_ORDER == __BIG_ENDIAN
#define U_BIG_ENDIAN
#undef  U_LITTLE_ENDIAN
#else /* __BYTE_ORDER == __LITTLE_ENDIAN */
#undef  U_BIG_ENDIAN
#define U_LITTLE_ENDIAN
#endif

#else
#error You loose, you should not use this computer
#endif

#endif                                                                              

/* 
   === constants 
*/
#if defined(AMIGA)

#define PATH_MAX FMSIZE


#ifndef S_IRUSR
#define S_IRUSR S_IREAD
#endif
#ifndef S_IWUSR
#define S_IWUSR S_IWRITE
#endif
#ifndef S_IRGRP
#define S_IRGRP S_IREAD
#endif
#ifndef S_IWGRP
#define S_IWGRP S_IWRITE
#endif
#ifndef S_IROTH
#define S_IROTH S_IREAD
#endif
#ifndef S_IWOTH
#define S_IWOTH S_IWRITE
#endif

#elif defined(__EMX__)

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#define INCL_BASE
#define INCL_PM
#include <os2.h>
#define PATH_MAX CCHMAXPATH

#endif

#if defined(AMIGA)
#elif defined(__EMX__) || defined(__OS2__)
#else
#define UNULLDEVICE "/dev/null"
#endif

/* 
   === macros 
*/
#if defined(__APPLE_CC__)
#include <c.h>
#endif
#ifndef min
#define min(a,b) ( (a) < (b) ) ? (a) : (b)
#endif

#ifndef max
#define max(a,b) ( (a) > (b) ) ? (a) : (b)
#endif
#if !defined(AMIGA)
#define iscsym(c) ( ( isalpha(c) || isdigit(c) ) ||(((c) & 127) == 0x5f))
#endif

                                      /* limit integer size to 32bit */
#define UMAXINT(len) ( (len) > ((size_t) INT_MAX) ) ? (INT_MAX) : ((int) ((ssize_t) len))


#ifdef U_BIG_ENDIAN
   typedef union { size_t ul; struct { uint32_t hi, lo; } ss; } UUSIZET2I32;
#elif defined(U_LITTLE_ENDIAN)        
   typedef union { size_t ul; struct { uint32_t lo, hi; } ss; } UUSIZET2I32;
#else
#error Unknown endianness
#endif


#if defined(__64BIT__) || defined(__LP64__)
#define  USIZET2I32(i32,ul64,oflo) { UUSIZET2I32 uu;\
                                    uu.ul = (ul64); i32 = uu.ss.lo; oflo = uu.ss.hi; if (i32<0) oflo = -1;}
#define USSIZET2I32(i32, l64,oflo) { UUSIZET2I32 uu;\
                                    uu.ul = ( l64); i32 = uu.ss.lo; oflo = uu.ss.hi; if ( (l64<0L) ) if ( (l64>=(-2147483647L-1L)) ) oflo = 0;}
#define    UI642I32(i32,ui64,oflo) { UUSIZET2I32 uu;\
                                    uu.ul = (ui64); i32 = uu.ss.lo; oflo = uu.ss.hi; if (i32<0) oflo = -1;}
#else
#define  USIZET2I32(i32,ul64,oflo) {                 i32 = (ul64);  oflo = 0;        if (i32<0) oflo = -1;}
#define USSIZET2I32(i32, l64,oflo) {                 i32 = ( l64);  oflo = 0; }
#define    UI642I32(i32,ui64,oflo) {                 i32 = (ui64);  oflo = 0;        if (i32<0) oflo = -1;}
#endif

                                      /* macro to increment a table organized as
                                      
                                         struct <base> {
                                            ...
                                            int n<Elm>, m<Elm>;
                                            struct ... *ps<Elm>; 
                                            ...
                                         }
                                          
                                      */
#define UTABLEINCREMENT(rc,base,Elm,INC) \
         (rc) = 0;\
         if ( (base)->n##Elm >= (base)->m##Elm ) {\
            void *pv = NULL;\
            (rc) = -1;\
            pv = realloc( (base)->ps##Elm, (ssize_t) ((base)->m##Elm+(INC)) * sizeof(*((base)->ps##Elm)) );\
            if ( pv != NULL ) {\
               (base)->ps##Elm = pv;\
               memset( &((base)->ps##Elm[(base)->m##Elm]), 0, (size_t) (INC) * sizeof(*((base)->ps##Elm) ) );\
               (base)->m##Elm += (INC);\
               (rc) = 0;\
            }\
         }                                

#endif                                                                              
