#ifndef VINTPOL_H 
#define VINTPOL_H

/** \file Definitions for interpolation functions.
*/
/*
   $Log: vintpol.h,v $
   Revision 1.2  2014/02/19 18:08:18  kraemer
   limbind added

   Revision 1.1.1.1  2009/05/07 12:58:14  kraemer


   Revision 1.1.2.1  2009/05/06 22:26:30  kraemer
   *** empty log message ***


*/

#include <sys/types.h>
#include <float.h>
#include <math.h>

#include "mtypes.h"

#define LIMBIND_ADJUST 0x00000001
int limbind( double [2], double *, size_t, size_t [2], unsigned int );

ssize_t vbind( double *, ssize_t, size_t,  double *, size_t, ssize_t *, ssize_t );
int vintpol1d( double *, ssize_t, size_t, double **, size_t, size_t, double *, ssize_t );
int vintpol1r( float  *, ssize_t, size_t, float  **, size_t, size_t, float  *, ssize_t ); 
int vintpolmt1d( double **, size_t, double **, size_t, size_t );
int vnear( double *, ssize_t, size_t, double *, size_t, ssize_t *, ssize_t );
void vnt2d( double *, double *, size_t, double *, size_t, size_t, double *);
/*
   --- FORTRAN entries
*/
#if defined(_AIX) || defined(ultrix)
void vnt1d_( double *, size_t *, double *, size_t *, size_t *, double *);
void vnv2dd_( double *, double *, size_t *, double *, size_t *, size_t *, double *);
#endif
#if defined(MVS) || defined(mvs)
void vnt1d ( double *, int *, double *, int *, int *, double *);
void vnv2dd ( double *, double *, int *, double *, int *, int *, double *);
#endif
/*
   --- C entries
*/
#if defined(MVS) || defined(mvs)
void vnt1d_( double *, int, double *, int, int, double *);
void vnv2dd_( double *, double *, int, double *, int, int, double *);
#define vnt1d  vnt1d_
#define vnv2dd vnv2dd_
#else
void vnt1d( double *, size_t, double *, size_t, size_t, double *);
void vnv2dd( double *, double *, size_t, double *, size_t, size_t, double *);
#endif

#endif
