#ifndef VMATHFCT_H 
#define VMATHFCT_H

/** \file Definitions for vector math functions.
*/
/*
   $Log: vmathfct.h,v $
   Revision 1.2  2015/01/05 19:04:52  kraemer
   *** empty log message ***

   Revision 1.1.1.1  2009/05/07 12:58:15  kraemer


   Revision 1.1.2.1  2009/05/06 22:26:30  kraemer
   *** empty log message ***

*/

#include <sys/types.h>
/*
#include <inttypes.h>
*/
#include <float.h>
#include <math.h>

#include "utypes.h"
#include "mtypes.h"

                                      /* */
void vfill( double, double *, size_t, size_t );
/*
void vifill( long, long *, long, long );
*/
void vmov  ( double *, size_t, double *, size_t, size_t );
/*
void vimov ( long *, long, long *, long, long);
*/
void vmrot ( double *, size_t, ssize_t, double *, size_t, size_t );
/*
void vgthx( long *, int, int, ... );
*/
ssize_t vnodup( double *, size_t, size_t, double *,size_t  );
void vshsrtd ( double **, size_t, size_t, size_t );
void SrtShell( double **, size_t, size_t );
ssize_t vrampd( double, double, double *, size_t, size_t );
void vramp ( double, double, double *, size_t, size_t );
void vslope( double *, size_t, double *, size_t, double *, size_t, size_t );
void vtrafo2 ( double *,  double [2][3], size_t, double * );
void vitrafo2( int16_t *, double [2][3], size_t, double * );
void vtrafo2i( double *,  double [2][3], size_t, int16_t * );
void vscequ( double *, double *, ssize_t, double *, ssize_t, size_t );


ssize_t v370s3E( uint32_t [], uint32_t [], size_t );
void vi2d( int16_t *, size_t, double *, size_t, size_t);
void vl2d( int32_t *, size_t, double *, size_t, size_t);
ssize_t vd2l( double *, size_t, int32_t *, size_t, size_t);
ssize_t vd2i( double *, size_t, int16_t *, size_t, size_t);
 

ssize_t maxv ( double *, size_t, double *, size_t *, size_t);
ssize_t minv ( double *, size_t, double *, size_t *, size_t);
ssize_t vmin ( double *, size_t, double *, size_t, double *, size_t, size_t);
ssize_t vmax ( double *, size_t, double *, size_t, double *, size_t, size_t);
ssize_t vsmax( double *, size_t, double, double *, size_t, size_t);
ssize_t vclip( double *, size_t, double, double, double *, size_t, size_t);
ssize_t vmom ( double *, size_t, double *, size_t, size_t, double [2][2], double *, int );

int vmindig10( double *, size_t, size_t);

/* obsolete ?
ssize_t viclip( short *, long, short, short, short *, long, long);
int vcvdb( double *, double , int , int , long *);
int  vwsdb ( double *, int, double *, int, long * );
int  vwsdx ( double *, int, double *, int, long * );
int  vwsd2x( double *, int, double *, int, double *, int, long * );
int  vwsd3b( double [3][2], int, int, double *, int, double *, int, double *, long * );
int  vwbd2b( double [], int, int, int, double *, int, double *, int, long * );
int v1dlapd( double [2], double [2] );
*/

ssize_t vadd ( double *, size_t, double *, size_t, double *, size_t, size_t);
ssize_t vsub ( double *, size_t, double *, size_t, double *, size_t, size_t);
ssize_t vmul ( double *, size_t, double *, size_t, double *, size_t, size_t);
ssize_t vdiv ( double *, size_t, double *, size_t, double *, size_t, size_t);
ssize_t vabs ( double *, size_t, double *, size_t, size_t);
ssize_t vneg ( double *, size_t, double *, size_t, size_t);
ssize_t vsadd( double *, size_t, double, double *, size_t, size_t);
ssize_t vsmul( double *, size_t, double, double *, size_t, size_t);
ssize_t svdiv( double, double *, size_t, double *, size_t, size_t);
ssize_t svsub( double, double *, size_t, double *, size_t, size_t);
ssize_t vasm ( double *, size_t, double *, size_t, double, double *, size_t, size_t);
ssize_t vsma ( double *, size_t, double, double *, size_t, double *, size_t, size_t);
ssize_t vsmsa( double *, size_t, double, double, double *, size_t, size_t);
/* ssize_t vsiadd( double *, long, int, double *, long, long); */

ssize_t vsqrt ( double *, size_t, double *, size_t, size_t);
ssize_t vlog  ( double *, size_t, double *, size_t, size_t);
ssize_t vlog10( double *, size_t, double *, size_t, size_t);
ssize_t vlog2 ( double *, size_t, double *, size_t, size_t);
ssize_t vexp  ( double *, size_t, double *, size_t, size_t);
ssize_t v10tox( double *, size_t, double *, size_t, size_t);
ssize_t vsin  ( double *, size_t, double *, size_t, size_t);
ssize_t vcos  ( double *, size_t, double *, size_t, size_t);
ssize_t vcosd ( double *, size_t, double *, size_t, size_t);
ssize_t vtan  ( double *, size_t, double *, size_t, size_t);
ssize_t vasin ( double *, size_t, double *, size_t, size_t);
ssize_t vacos ( double *, size_t, double *, size_t, size_t);
ssize_t vacosd( double *, size_t, double *, size_t, size_t);
ssize_t vatan ( double *, size_t, double *, size_t, size_t);
ssize_t vsinh ( double *, size_t, double *, size_t, size_t);
ssize_t vcosh ( double *, size_t, double *, size_t, size_t);
ssize_t vtanh ( double *, size_t, double *, size_t, size_t);
ssize_t vasinh( double *, size_t, double *, size_t, size_t);
ssize_t vacosh( double *, size_t, double *, size_t, size_t);
ssize_t vatanh( double *, size_t, double *, size_t, size_t);
ssize_t svpow ( double, double *, size_t, double *, size_t, size_t);
ssize_t vpow  ( double *, size_t, double *, size_t, double *, size_t, size_t);
ssize_t vspow ( double *, size_t, double, double *, size_t, size_t);
ssize_t vspowi( double *, size_t,    int, double *, size_t, size_t);
void vellipse( double *, size_t, double * );


ssize_t vleg    ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vlegevn ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vlegodd ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vlegn   ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vlegevnn( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vlegoddn( double *, size_t, double *, int, double *, size_t, double *, size_t );

ssize_t vexpon   ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vpoly    ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vlortz   ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vgauss   ( double *, size_t, double *, int, double *, size_t, double *, size_t );
ssize_t vgaussint( double *, size_t, double *, int, double *, size_t, double *, size_t );

#endif
